Redmine - Feature #34703

"Copy link" feature for issue and issue journal
2021-02-10 09:01 - Mizuki ISHIKAWA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Mizuki ISHIKAWA % Done: 0%
Category: ul Estimated time: 0.00 hour
Target version: 4.2.0

Resolution: Fixed

Description

When you are looking at a issue with Redmine and want to share the URL, if you copy the URL with a browser, it will be a long URL
with many unnecessary parameters such as issue_count and prev_issue_id.

| think it would be convenient to be able to copy a simple URL from the view.

e URL of the issue to be copiedll https://<your redmine>/issues/1
 URL of the issue journal to be copiedll http://<your redmine>/issues/1#note-1

Related issues:
Related to Redmine - Feature #34714: Move delete button for issues and journa... Closed
Related to Redmine - Feature #34932: "Copy link" feature for issues list Closed

Associated revisions

Revision 20816 - 2021-03-18 04:58 - Go MAEDA

"Copy link" feature for issue and issue journal (#34703).

Patch by Mizuki ISHIKAWA.

Revision 20817 - 2021-03-18 05:12 - Go MAEDA
Update locales (#34703).

History

#1 - 2021-02-10 09:11 - Mizuki ISHIKAWA

- File feature-34703-1.patch added

- File screenshot_2021-02-10_16.15.22.png added
- File screenshot_2021-02-10_16.14.35.png added

When | added the "Copy link" icon, it was crowded with many icons displayed on the view.
So this patch hides infrequently used action links in actions-dropdown, just like wiki pages.

screenshot_2021-02-10_16.15.22.png
screenshot_2021-02-10_16.14.35.png
If it is better to separate the patch that adds the function to copy the URL and the patch that combines the Action icons, it will be supported.
This patch contains an icon image, so apply it with the git apply command.

#2 - 2021-02-10 09:18 - Mizuki ISHIKAWA
- File diff-rejected.patch added

For your reference, I've attached a patch with a pattern that doesn't combine the "Copy link" icon into actions-dropdown. (I don't like this Ul very
much)

#3 - 2021-02-10 23:57 - Marius BALTEANU

| really like the ideea of moving the Delete icons under the actions dropdown, | think we should extract it from your patch and added a separat tichet.
From my point of view, this solution is a good fix for #31278.

Also, having the copy link it's a nice and useful feature.

#4 - 2021-02-11 05:05 - Bernhard Rohloff
https://www.redmine.org/issues/31278

Marius BALTEANU wrote:

| really like the ideea of moving the Delete icons under the actions dropdown, | think we should extract it from your patch and added a separat
tichet. From my point of view, this solution is a good fix for #31278.

Good point there.

Also, having the copy link it's a nice and useful feature.

| like the feature, too. Sharing a link in a chat is a bit tedious at the moment.
I've tried your patch and it worked quite well. The only thing I've missed was some kind of feedback after copying the URL to the clipboard. On all web

applications which allowed me to copy stuff to the clipboard | got a toast or little message, that the job has finished. So | felt a bit awkward after
clicking the copy link without anything happening.

#5 - 2021-02-12 08:24 - Mizuki ISHIKAWA
Thank you for your feedback.
Marius BALTEANU wrote:
| really like the ideea of moving the Delete icons under the actions dropdown, | think we should extract it from your patch and added a separat

tichet. From my point of view, this solution is a good fix for #31278.

| split the patch and attached it to the #34714 issue.

Bernhard Rohloff wrote:

I've tried your patch and it worked quite well. The only thing I've missed was some kind of feedback after copying the URL to the clipboard. On all
web applications which allowed me to copy stuff to the clipboard | got a toast or little message, that the job has finished. So | felt a bit awkward
after clicking the copy link without anything happening.

I think if | put the "Copy link" link inside the Actions dropdown, pressing the copy button will close the Dropdown as feedback that the work is done.
GitHub and Gitlab also put a "Copy link" in the dropdown and do not show the message that the work is completed.

However, if you accidentally click outside the dropdown, the dropdown will close, which may be incomplete feedback in that you don't know if the copy
is really complete.

In the patch for #34703#note-2, | have implemented a mechanism to display a message after the copy is completed, so | will try if | can incorporate
that into the patch for #34703#note-1.

#6 - 2021-03-03 22:04 - Marius BALTEANU

- Related to Feature #34714: Move delete button for issues and journals to the dropdown menu added

#7 - 2021-03-09 03:17 - Mizuki ISHIKAWA
- File 0001-Add-link-to-copy-object-s-url-to-the-clipboard.patch added

Since #34714 was committed, | modified feature-34703-1.patch accordingly.
| also added a System test.

#8 - 2021-03-09 04:03 - Go MAEDA

Bernhard Rohloff wrote:
The only thing I've missed was some kind of feedback after copying the URL to the clipboard. On all web applications which allowed me to copy
stuff to the clipboard | got a toast or little message, that the job has finished. So | felt a bit awkward after clicking the copy link without anything
happening.

| agree that it would be even better to have feedback when the link is copied.

But how about committing the current patch first, and improving the feedback display in the future? | think the feature is useful even without feedback.
And as Mizuki already wrote, the equivalent feature of GitHub and Gitlab also don't show feedback when a link is copied.

#9 - 2021-03-09 05:21 - Bernhard Rohloff
Go MAEDA wrote:

But how about committing the current patch first, and improving the feedback display in the future? | think the feature is useful even without
feedback. And as Mizuki already wrote, the equivalent feature of GitHub and Gitlab also don't show feedback when a link is copied.
Of course! It's a useful feature and we should add it to Redmine. A bit of feedback would just be the icing on the cake. :-)

#10 - 2021-03-09 06:56 - Go MAEDA

- Target version set to Candidate for next major release

#11 - 2021-03-16 03:20 - Mizuki ISHIKAWA
- File 0001-Add-link-to-copy-object-s-url-to-the-clipboard.patch added
- File screenshot-2021-03-16-11.20.14.png added

| changed the icon to an image created by combining a copy icon and a link icon.

screenshot-2021-03-16-11.20.14.png

#12 - 2021-03-16 03:23 - Mizuki ISHIKAWA

Bernhard Rohloff wrote:
Go MAEDA wrote:

But how about committing the current patch first, and improving the feedback display in the future? | think the feature is useful even without
feedback. And as Mizuki already wrote, the equivalent feature of GitHub and Gitlab also don't show feedback when a link is copied.

Of course! It's a useful feature and we should add it to Redmine. A bit of feedback would just be the icing on the cake. :-)

I've also written a patch that adds feedback, but I'm a little confused about how to implement it, so I'm thinking of making another issue after this
feature is committed.

#13 - 2021-03-16 03:34 - Mizuki ISHIKAWA
- File 0001-Add-link-to-copy-object-s-url-to-the-clipboard.patch added

Mizuki ISHIKAWA wrote:

| changed the icon to an image created by combining a copy icon and a link icon.

| accidentally attached an old patch.

#14 - 2021-03-16 04:55 - Go MAEDA

- Target version changed from Candidate for next major release to 4.2.0

Setting the target version to 4.2.0.

#15 - 2021-03-17 09:30 - Go MAEDA
- Assignee set to Mizuki ISHIKAWA

test/system/copy_to_clipboard_test.rb fails on macOS. Could you fix the test to support macOS? Probably

;trunk/ m/ki rd_shor _test.rb@20729#L125 is helpful.
[Screenshot]: tmp/screenshots/failures_test_copy_issue_url_to_clipboard.png
F
Failure:

CopyToClipboardSystemTest#test_copy_issue_url_to_clipboard [test/system/copy_to_clipboard_test.rb:40]:
Expected false to be truthy.

bin/rails test test/system/copy_to_clipboard_test.rb:29

[Screenshot]: tmp/screenshots/failures_test_copy_issue_journal_url_to_clipboard.png
F

Failure:

CopyToClipboardSystemTest#test_copy_issue_Jjournal_url_to_clipboard [test/system/copy_to_clipboard_test.rb:54]:
Expected false to be truthy.
bin/rails test test/system/copy_to_clipboard_test.rb:43

#16 - 2021-03-18 01:55 - Mizuki ISHIKAWA
- File 0002-Fix-to-change-the-shortcut-key-according-to-the-OS.patch added

Go MAEDA wrote:

test/system/copy_to_clipboard_test.rb fails on macOS. Could you fix the test to support macOS? Probably
source:trunk/test/system/keyboard_shortcuts_test.ro@20729#L125 is helpful.

(-]

I think it will be fixed by applying this patch in addition to the 0001 patch.

#17 - 2021-03-18 05:00 - Go MAEDA

- Subject changed from Add a link to copy the issue URL and issue journal URL to the clipboard to "Copy link" feature for issue issue journal

- Status changed from New to Closed

- Resolution set to Fixed

Committed the patch. Thank you for your contribution.

Users can copy a URL of an issue or an issue journal by clicking "Copy link" in the action menu.

#18 - 2021-03-18 05:10 - Go MAEDA

- Subject changed from "Copy link" feature for issue issue journal to "Copy link" feature for issue and issue journal

#19 - 2021-03-19 06:40 - Go MAEDA
- Related to Feature #34932: "Copy link" feature for issues list added

Files

feature-34703-1.patch 7.1 KB 2021-02-10 Mizuki ISHIKAWA
screenshot_2021-02-10_16.15.22.png 69.9 KB 2021-02-10 Mizuki ISHIKAWA
screenshot_2021-02-10_16.14.35.png 112 KB 2021-02-10 Mizuki ISHIKAWA
diff-rejected.patch 6.7 KB 2021-02-10 Mizuki ISHIKAWA
0001-Add-link-to-copy-object-s-url-to-the-clipboard.patch 10.6 KB 2021-03-09 Mizuki ISHIKAWA
0001-Add-link-to-copy-object-s-url-to-the-clipboard.patch 10.6 KB 2021-03-16 Mizuki ISHIKAWA
screenshot-2021-03-16-11.20.14.png 46.6 KB 2021-03-16 Mizuki ISHIKAWA
0001-Add-link-to-copy-object-s-url-to-the-clipboard.patch 12.4 KB 2021-03-16 Mizuki ISHIKAWA
0002-Fix-to-change-the-shortcut-key-according-to-the-OS.patch 1.44 KB 2021-03-18 Mizuki ISHIKAWA
